jQueryTS(function () {
  var ScheduledIssue = TheScheduler.namespace('TheScheduler.Model.ScheduledIssue');
  var ScheduledIssueTable = TheScheduler.namespace('TheScheduler.View.ScheduledIssueTable');
  var ConfigureColumnsInlineDialog = TheScheduler.namespace('TheScheduler.View.ConfigureColumnsInlineDialog');
  var FireSelectedConfirmationDialog = TheScheduler.namespace('TheScheduler.View.FireSelectedConfirmationDialog');
  var DeleteDialog = TheScheduler.namespace('TheScheduler.View.DeleteDialog');
  var DeleteSelectedDialog = TheScheduler.namespace('TheScheduler.View.DeleteSelectedDialog');
  var EnableDisableSelectedDialog = TheScheduler.namespace('TheScheduler.View.EnableDisableSelectedDialog');
  var CloneDialog = TheScheduler.namespace('TheScheduler.View.CloneDialog');
  var ErrorDialog = TheScheduler.namespace('TheScheduler.View.ErrorDialog');
  var ShowFutureFiresDialog = TheScheduler.namespace('TheScheduler.View.ShowFutureFiresDialog');
  var ShowCreatedIssuesDialog = TheScheduler.namespace('TheScheduler.View.ShowCreatedIssuesDialog');
  var Notification = TheScheduler.namespace('TheScheduler.Utils.Notification');
  var BulkCloneDialog = TheScheduler.namespace('TheScheduler.View.BulkCloneDialog');

    var scheduledIssueTable = null;
    var configureColumnsInlineDialog = null;
    var userFilter = null;
    var refreshBtn = null;

    AJS.$(".scheduler-tooltip-enabled").tooltip();

    AJS.params.loggedInUser = AJS.$("#loggedInUser").val();

    function initScheduledIssuesTab() {
        /* VARIABLE INITIALIZATION */

        if (scheduledIssueTable === null) {
            scheduledIssueTable = new ScheduledIssueTable("#scheduled-issues-table");
        }
        if (configureColumnsInlineDialog === null) {
            configureColumnsInlineDialog = new ConfigureColumnsInlineDialog(scheduledIssueTable, projectId.value);
        }
        var ajaxRequestGetUserColumns = jQueryTS.ajax({
          "type": "GET",
          "url": AJS.contextPath() + "/rest/thescheduler/1.0/users/properties/columns?projectId=" + projectId.value,
          "contentType": "application/json; charset=UTF-8",
          "async": false,
        });
        ajaxRequestGetUserColumns.done(function(data) {
          scheduledIssueTable.setColumnVisibleByNameWithoutRedraw(data.columns);
        });
        if (userFilter === null) {
            userFilter = jQueryTS("#user-filter-tf");
        }
        if (refreshBtn === null) {
            refreshBtn = jQueryTS("#refresh-button");
        }

        var ajaxRequest = jQueryTS.ajax({
        "type": "GET",
        "url": AJS.contextPath() + "/rest/thescheduler/1.0/global/clone-prefix",
        "dataType": "json",
        "async": false
        }).done(function (data) {
          AJS.$('#jiraClonePrefix').val(data.clonePrefix);
        });

        /* USER FILTER */
        function filter(text) {
            var dataTable = scheduledIssueTable.getDataTable();
            dataTable.fnFilter(text);
        }

        userFilter.bind("input", jQuery.debounce(250, function () {
            filter(AJS.$(this).val());
        }));

        jQueryTS("#user-filter-form").submit(function(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();
            return false;
        });
        /* USER FILTER ENDS */

        /* SHOW ALL FUTURE FIRES */
        function showFutureFires(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            var showFutureFiresDialog;

            var selectedScheduledIssuesIdsArray = [];
            var selectedScheduledIssuesNamesArray = [];

            var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();

            if(selectedScheduledIssues.length > 0) {
                for(var i = 0; i < selectedScheduledIssues.length; i++) {
                    selectedScheduledIssuesIdsArray.push(selectedScheduledIssues[i].id);
                    selectedScheduledIssuesNamesArray.push(selectedScheduledIssues[i].name);
                }
                showFutureFiresDialog = new ShowFutureFiresDialog(selectedScheduledIssuesIdsArray, selectedScheduledIssuesNamesArray);
                showFutureFiresDialog.show();
            }
            else {
                showFutureFiresDialog = new ShowFutureFiresDialog(null, null, projectId.value, projectName.value);
                showFutureFiresDialog.show();
            }
            return false;
        }

        jQueryTS("#show-scheduled-issue-creation-link").click(showFutureFires);
        /* SHOW ALL FUTURE FIRES ENDS */

        /* SHOW FUTURE FIRES FOR SI */
        function showFutureFiresForScheduledIssue(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            var dropdownDivElement = jQueryTS(this).closest("div");
            var dropdownDivId = dropdownDivElement.attr("id");
            var trElement = jQueryTS("a[href='#" + dropdownDivId + "']").closest("tr");

            var dataTable = scheduledIssueTable.getDataTable();
            var scheduledIssue = dataTable.fnGetData(trElement.get(0));

            var arrayId = [];
            var arrayName = [];
            arrayId.push(scheduledIssue.id);
            arrayName.push(scheduledIssue.name);
            var showFutureFiresDialog = new ShowFutureFiresDialog(arrayId, arrayName);
            showFutureFiresDialog.show();

            return false;
        }

        jQueryTS("body").off("click", "a.show-future-fires-link");
        jQueryTS("body").on("click", "a.show-future-fires-link", showFutureFiresForScheduledIssue);
        /* SHOW FUTURE FIRES FOR SI ENDS */

        /* CREATE SCHEDULED ISSUE CLICK START */
        function onCreateIssueClick(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            licenseCheckRequest().done(function (response) {
                response.valid ? goToCreateScheduleIssuePage() : showLicenseError();
            });
            return false;
        }
        function goToCreateScheduleIssuePage() {
            var hrefUrl = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.CreateScheduledIssue!default.jspa';
            if (projectId.value) {
                hrefUrl += '?projectId=' + projectId.value;
            }
            window.location.href = hrefUrl;
        }
        jQueryTS("button[name='create-scheduled-issue']").click(onCreateIssueClick);
        /* CREATE SCHEDULED ISSUE CLICK END */

        /* SHOW CREATED ISSUES */
        function showCreatedIssues(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            var selectedScheduledIssuesIdsArray = [];
            var selectedScheduledIssuesNamesArray = [];
            var selectedScheduledIssuesProjectsArray = [];

            var showCreatedIssuesDialog = null;

            var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();

            if (selectedScheduledIssues.length > 0) {
                for(var i = 0; i < selectedScheduledIssues.length; i++) {
                    selectedScheduledIssuesIdsArray.push(selectedScheduledIssues[i].id);
                    selectedScheduledIssuesNamesArray.push(selectedScheduledIssues[i].name);
                    selectedScheduledIssuesProjectsArray.push(selectedScheduledIssues[i].projectId);
                }
                showCreatedIssuesDialog = new ShowCreatedIssuesDialog(selectedScheduledIssuesIdsArray, selectedScheduledIssuesNamesArray,
                    selectedScheduledIssuesProjectsArray, null);
                showCreatedIssuesDialog.show();
            }
            else {
                showCreatedIssuesDialog = new ShowCreatedIssuesDialog(null, null, Array.of(projectId.value), projectName.value);
                showCreatedIssuesDialog.show();
            }

            return false;
        }

        jQueryTS("body").off("click", "[name^=show-created-issues]");
        jQueryTS("body").on("click", "[name^=show-created-issues]", showCreatedIssuesForScheduledIssue);

        jQueryTS("#show-created-issues-for-project").click(showCreatedIssues);

        function showCreatedIssuesForScheduledIssue(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            var dropdownDivElement = jQueryTS(this).closest("div");
            var dropdownDivId = dropdownDivElement.attr("id");
            var trElement = jQueryTS("a[href='#" + dropdownDivId + "']").closest("tr");

            var dataTable = scheduledIssueTable.getDataTable();
            var scheduledIssue = dataTable.fnGetData(trElement.get(0));

            var arrayId = [];
            var arrayName = [];
            var arrayProject = [];
            arrayId.push(scheduledIssue.id);
            arrayName.push(scheduledIssue.name);
            arrayProject.push(scheduledIssue.projectId);
            var showCreatedIssuesDialog = new ShowCreatedIssuesDialog(arrayId, arrayName, arrayProject, null);
            showCreatedIssuesDialog.show();

            return false;
        }
        /* SHOW CREATED ISSUES ENDS */

        /* TABLE ROWS NUMBER CHANGE */
        function rowsAmountChange(amount) {
            scheduledIssueTable.displayLengthChange(amount);
            return false;
        }

        jQueryTS("a#tl-10").click(function () {
            rowsAmountChange(10);
        });
        jQueryTS("a#tl-25").click(function () {
            rowsAmountChange(25);
        });
        jQueryTS("a#tl-50").click(function () {
            rowsAmountChange(50);
        });
        jQueryTS("a#tl-100").click(function () {
            rowsAmountChange(100);
        });
        /* TABLE ROWS NUMBER CHANGE ENDS */

        /* REFRESH TABLE */
        function refreshScheduledIssues(eventObject) {
            if (eventObject) {
                eventObject.preventDefault();
                eventObject.stopPropagation();
            }

            refreshBtn.attr("aria-disabled", "true");
            refreshBtn.attr("disabled", "disabled");
            jQueryTS(".refresh-scheduled-issues", refreshBtn).hide();
            jQueryTS(".refreshing-scheduled-issues", refreshBtn).removeClass('hide');

            scheduledIssueTable.refresh(function () {
                jQueryTS(".refresh-scheduled-issues", refreshBtn).show();
                jQueryTS(".refreshing-scheduled-issues", refreshBtn).addClass('hide');
                refreshBtn.attr("aria-disabled", "false");
                refreshBtn.removeAttr("disabled", "disabled");
                selectionChanged();
            });

            return false;
        }

        refreshBtn.click(refreshScheduledIssues);
        /* REFRESH TABLE ENDS */

        /* CLONE SI */
        function cloneScheduledIssue(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

          licenseCheckRequest()
            .done(function (response) {
              if (response.valid) {
                var dropdownDivElement = jQueryTS(eventObject.currentTarget)
                  .closest('div');
                var dropdownDivId = dropdownDivElement.attr('id');
                var trElement = jQueryTS("a[href='#" + dropdownDivId + "']").closest("tr");

                var dataTable = scheduledIssueTable.getDataTable();
                var scheduledIssue = dataTable.fnGetData(trElement.get(0));

                var cloneDialog = new CloneDialog(scheduledIssue, function (response, serializeObject) {
                  jQueryTS.ajax({
                    type: 'GET',
                    url: AJS.contextPath() + '/rest/thescheduler/1.0/validations/scheduled-issue/' + response,
                    dataType: 'json',
                    async: true,
                    success: function (data) {
                      if (serializeObject.editAfterCloning === true) {
                        document.location.href = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa?scheduledIssueId=' + response;
                      } else if (data.valid === false) {
                        document.location.href = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa?scheduledIssueId=' + response + '&editionAfterClone=true';
                      } else {
                        Notification.showNotification(
                          'success',
                          AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success'),
                          AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success.desc'),
                          '#scheduled-issues-table-messages'
                        );
                        scheduledIssueTable.refresh(function () {
                          selectionChanged();
                        });
                      }
                    }
                  });
                });
                cloneDialog.show();
              } else {
                showLicenseError();
              }
            });
        }

        jQueryTS("body").off("click", "a.clone-link");
        jQueryTS("body").on("click", "a.clone-link", cloneScheduledIssue);
        /* CLONE SI ENDS */

        function onEditTriggersClick(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            licenseCheckRequest()
                .done(function (response) {
                    if (response.valid) {
                        var dropdownDivElement = jQueryTS(eventObject.currentTarget).closest("div");
                        var dropdownDivId = dropdownDivElement.attr("id");
                        var trElement = jQueryTS("a[href='#" + dropdownDivId + "']").closest("tr");

                        var dataTable = scheduledIssueTable.getDataTable();
                        var scheduledJob = dataTable.fnGetData(trElement.get(0));

                        AJS.$("#scheduled-issues-table").trigger({
                            type: "tsp:editSITriggersButtonClick",
                            scheduledJob: scheduledJob,
                        })
                    } else {
                        showLicenseError();
                    }
                });

        }
        jQueryTS("body").on("click", "a.edit-triggers-si-action-link", onEditTriggersClick);

        AJS.$("#scheduled-issues-table").on("tsp:siTriggersChange", function(event) {
            scheduledIssueTable.refresh()
        });

      /* ON SI-ACTION-LINK */
      function onEditLinkClick(event) {
        event.preventDefault();
        event.stopPropagation();

        const hrefUrl = event.target.localName == 'span' ? event.currentTarget.href : event.target.href;

        licenseCheckRequest()
          .done(function (response) {
            response.valid ? window.location.href = hrefUrl : showLicenseError();
          });
      }
      jQueryTS("body").on("click", ".si-action-link", onEditLinkClick);
      /* ON SI-ACTION-LINK END */

        /* DELETE ONE SI */
        function deleteScheduledIssue(eventObject) {
            eventObject.preventDefault();
            eventObject.stopPropagation();

            var dropdownDivElement = jQueryTS(this).closest("div");
            var dropdownDivId = dropdownDivElement.attr("id");
            var trElement = jQueryTS("a[href='#" + dropdownDivId + "']").closest("tr");

            var dataTable = scheduledIssueTable.getDataTable();
            var scheduledIssue = dataTable.fnGetData(trElement.get(0));

            var deleteDialog = new DeleteDialog(scheduledIssue, function () {
                trElement.fadeOut(500, function () {
                    var pos = dataTable.fnGetPosition(trElement.get(0));
                    dataTable.fnDeleteRow(pos);
                    if(dataTable.fnGetData().length == 0) {
                        scheduledIssueTable.showEmptyTableInfo();
                    }
                    selectionChanged();
                });
            });
            deleteDialog.show();
            return false;
        }

        jQueryTS("body").off("click", "a.delete-link");
        jQueryTS("body").on("click", "a.delete-link", deleteScheduledIssue);
        /* DELETE ONE SI ENDS */

        /* DELETE SELECTED SIs */
        function deleteScheduledIssues(eventObject) {
            var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();

            var deleteSelectedDialog = new DeleteSelectedDialog(selectedScheduledIssues, function (deleteResults) {
                var dataTable = scheduledIssueTable.getDataTable();
                for (var i = 0; i < deleteResults.length; i++) {
                    var deleteResult = deleteResults[i];
                    scheduledIssueTable.deleteScheduledIssue(deleteResult.scheduledIssueId, function (scheduledIssueIndex, trRow) {
                        jQueryTS(trRow).fadeOut(500);
                    });
                }
                scheduledIssueTable.redraw();
                if(dataTable.fnGetData().length == 0) {
                    scheduledIssueTable.showEmptyTableInfo();
                }
                scheduledIssueTable.refresh(function () {
                    selectionChanged();
                    scheduledIssueTable.updateSelectedRowsCounters();
                    document.getElementById("checkbox-select-unselect-all-si-in-table").checked = false;
                });
                document.getElementById("checkbox-select-unselect-all-si-in-table").checked = false;
            });
            deleteSelectedDialog.show();
            return false;
        }
        jQueryTS("#delete-selected-button").click(deleteScheduledIssues);
        /* DELETE SELECTED SIs ENDS */

      function refreshTableSectionAndCounters() {
        var dataTable = scheduledIssueTable.getDataTable();

        if (dataTable.fnGetData().length == 0) {
          scheduledIssueTable.showEmptyTableInfo();
        }
        scheduledIssueTable.unselectAll();
        scheduledIssueTable.updateSelectedRowsCounters();
        scheduledIssueTable.refresh(function () {
          selectionChanged();
        });
      }

      /* ENABLE SELECTED SIs */
        function enableScheduledIssues(eventObject) {
          licenseCheckRequest()
            .done(function (response) {
              if (response.valid) {
                var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();

                var enableSelectedDialog = new EnableDisableSelectedDialog(selectedScheduledIssues, refreshTableSectionAndCounters);
                enableSelectedDialog.show();
                return false;
              } else {
                showLicenseError();
              }
            });

        }

        jQueryTS('#enable-selected-button')
          .click(enableScheduledIssues);

        /* EXECUTE SELECTED SIs */
        function executeScheduledIssues(eventObject) {
          licenseCheckRequest()
            .done(function (response) {
              if (response.valid) {
                var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();

                var isAnyTriggerSkipping = false;
                var isAnyFieldSwapping = false;

                for (var i = 0; i < selectedScheduledIssues.length; i++) {
                  if (!isAnyTriggerSkipping) {
                    isAnyTriggerSkipping = selectedScheduledIssues[i].anyTriggerSkipping;
                  }
                  if (!isAnyFieldSwapping) {
                    isAnyFieldSwapping = selectedScheduledIssues[i].swappingAnyUserField;
                  }
                  if (isAnyFieldSwapping && isAnyTriggerSkipping) {
                    break;
                  }
                }

                var selectedScheduledIssuesBean = {
                  scheduledIssueIdsToExecute: selectedScheduledIssues.map(function (scheduledIssue) {
                    return scheduledIssue.id;
                  }),
                };

                var executeSelectedDialog = new FireSelectedConfirmationDialog(selectedScheduledIssues.length,
                  isAnyTriggerSkipping, isAnyFieldSwapping, function () {
                    var ajaxRequest = jQueryTS.ajax({
                        type: 'POST',
                        url: AJS.contextPath() + '/rest/thescheduler/1.0/scheduled-issue/fire',
                        contentType: 'application/json',
                        dataType: 'json',
                        data: JSON.stringify(selectedScheduledIssuesBean),
                        async: true
                    });


                    ajaxRequest.done(function(data) {
                        if(data.every(function(fireHistoryEntry) {
                            return fireHistoryEntry.executionResult !== "FAILED";
                        })) {
                            Notification.showNotification(
                                'success',
                                AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.fired-selected"),
                                AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.fired-selected.desc"),
                                '#scheduled-issues-table-messages'
                            );
                        } else {
                            Notification.showNotification(
                                'error',
                                AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.fired-selected.error"),
                                AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.fired-selected.error.desc"),
                                '#scheduled-issues-table-messages'
                            );
                        }

                    });
                });

                executeSelectedDialog.show();
              }
              else {
                  showLicenseError();
              }
              });
            return false;
        }
        jQueryTS("#execute-selected-button").click(executeScheduledIssues);
        /* EXECUTE SELECTED SIs ENDS */

        /* EDIT SELECTED SIs */
        function editScheduledIssues(eventObject) {
            licenseCheckRequest()
                .done(function(response) {
                    if(response.valid) {
                        var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();
                        if (selectedScheduledIssues.length > 0) {
                            var url;

                            if (selectedScheduledIssues.length === 1) {
                                var id = selectedScheduledIssues[0].id;
                                url = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa?scheduledIssueId=' + id;
                            } else {
                                var ids = '';
                                for (var i = 0; i < selectedScheduledIssues.length; i++) {
                                    ids += selectedScheduledIssues[i].id + ',';
                                }
                                ids = ids.substr(0, ids.length - 1);
                                url = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.BulkEditSI!default.jspa?selectedForEdit=' + ids;
                            }
                            window.location.replace(url);
                        }
                    }
                    else {
                        showLicenseError();
                    }
                });
        }
        jQueryTS("#edit-selected-button").click(editScheduledIssues);
        /* EDIT SELECTED SIs ENDS */

        /* SHARE SELECTED SIs */
        function shareScheduledIssues(eventObject) {
            licenseCheckRequest()
                .done(function(response) {
                    if(response.valid) {
                        var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();
                        if (selectedScheduledIssues.length > 0) {
                            var url;

                            if (selectedScheduledIssues.length === 1) {
                                var id = selectedScheduledIssues[0].id;
                                url = AJS.contextPath() + '/secure/ShareScheduledIssue!default.jspa?scheduledIssueId=' + id;
                            } else {
                                var ids = '';
                                for (var i = 0; i < selectedScheduledIssues.length; i++) {
                                    ids += selectedScheduledIssues[i].id + ',';
                                }
                                ids = ids.substr(0, ids.length - 1);
                                url = AJS.contextPath() + '/secure/BulkShareSI!default.jspa?selectedForShare=' + ids;
                            }
                            window.location.replace(url);
                        }
                    }
                    else {
                        showLicenseError();
                    }
                });
        }

        jQueryTS("#share-selected-button").click(shareScheduledIssues);
        /* SHARE SELECTED SIs ENDS */

        function validateClonedSelectedSIs(clonedScheduledIssuesId) {
            jQueryTS.ajax({
                type: 'POST',
                url: AJS.contextPath() + '/rest/thescheduler/1.0/validations/scheduled-issue/bulk',
                contentType: 'application/json',
                dataType: 'json',
                data: JSON.stringify(clonedScheduledIssuesId),
                async: true,
                success: function (data) {
                    if(data.every(function(data) {
                        return data.valid === true;
                    })) {
                        Notification.showNotification(
                            'success',
                            AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success'),
                            AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success.desc'),
                            '#scheduled-issues-table-messages'
                        );
                    } else {
                        var invalidSINames = data.map(function (currentValue, key) {
                            if(!currentValue.valid) {
                                return currentValue.scheduledIssue.name;
                            }
                        });
                        Notification.showNotification(
                            'error',
                            AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.error'),
                            AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.error.desc', invalidSINames),
                            '#scheduled-issues-table-messages'
                        );
                    }
                }
            });
        }

        /* CLONE SELECTED SIs */
        function cloneScheduledIssues(eventObject) {
            licenseCheckRequest()
                .done(function(response) {
                    if(response.valid) {
                        var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();
                        if(selectedScheduledIssues.length > 1) {
                          var bulkCloneDialog = new BulkCloneDialog(selectedScheduledIssues, function (clonedScheduledIssuesId) {
                            validateClonedSelectedSIs(clonedScheduledIssuesId);
                            refreshTableSectionAndCounters();
                          });
                          bulkCloneDialog.show();
                        }
                        else {
                          var dropdownDivElement = jQueryTS(eventObject.currentTarget)
                            .closest('div');
                          var dropdownDivId = dropdownDivElement.attr('id');
                          var trElement = jQueryTS('a[href=\'#' + dropdownDivId + '\']')
                            .closest('tr');

                          var dataTable = scheduledIssueTable.getDataTable();
                          var scheduledIssue = selectedScheduledIssues[0];

                          var cloneDialog = new CloneDialog(scheduledIssue, function (response, serializeObject) {
                            jQueryTS.ajax({
                              type: 'GET',
                              url: AJS.contextPath() + '/rest/thescheduler/1.0/validations/scheduled-issue/' + response,
                              dataType: 'json',
                              async: true,
                              success: function (data) {
                                if (serializeObject.editAfterCloning === true) {
                                  document.location.href = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa?scheduledIssueId=' + response;
                                } else if (data.valid === false) {
                                  document.location.href = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa?scheduledIssueId=' + response + '&editionAfterClone=true';
                                } else {
                                  Notification.showNotification(
                                    'success',
                                    AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success'),
                                    AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.clone.success.desc'),
                                    '#scheduled-issues-table-messages'
                                  );
                                  scheduledIssueTable.refresh(function () {
                                    selectionChanged();
                                  });
                                }
                              }
                            });
                          });
                          cloneDialog.show();
                        }
                    }
                    else {
                        showLicenseError();
                    }
                });
        }
        jQueryTS('#clone-selected-button').click(cloneScheduledIssues);
        /* CLONE SELECTED SIs ENDS */

    /* DISABLE UNALLOWED BUTTONS */
    function selectionChanged(eventObject) {
      var executeSelectedLinkHolder = AJS.$('#execute-selected-button-holder').attr('original-title', '');
      var editSelectedLinkHolder = AJS.$('#edit-selected-button-holder').attr('original-title', '');
      var shareSelectedLinkHolder = AJS.$('#share-selected-button-holder').attr('original-title', '');
      var deleteSelectedLinkHolder = AJS.$('#delete-selected-button-holder').attr('original-title', '');
      var cloneSelectedLinkHolder = AJS.$('#clone-selected-button-holder').attr('original-title', '');
      var enableSelectedLinkHolder = AJS.$('#enable-selected-button-holder').attr('original-title', '');

      executeSelectedLinkHolder.tooltip('disable');
      editSelectedLinkHolder.tooltip('disable');
      shareSelectedLinkHolder.tooltip('disable');
      deleteSelectedLinkHolder.tooltip('disable');
      cloneSelectedLinkHolder.tooltip('disable');
      enableSelectedLinkHolder.tooltip('disable');

      var executeSelectedLink = AJS.$('#execute-selected-button').removeAttr('disabled');
      var editSelectedLink = AJS.$('#edit-selected-button').removeAttr('disabled');
      var shareSelectedLink = AJS.$('#share-selected-button').removeAttr('disabled');
      var deleteSelectedLink = AJS.$('#delete-selected-button').removeAttr('disabled');
      var cloneSelectedLink = AJS.$('#clone-selected-button').removeAttr('disabled');
      var enableSelectedLink = AJS.$('#enable-selected-button').removeAttr('disabled');

      var selectedScheduledIssues = scheduledIssueTable.getSelectedScheduledIssues();
      if (selectedScheduledIssues.length === 0) {
        var notSelectedText = AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.not-selected-tooltip');
        executeSelectedLink.attr('disabled', '');
        editSelectedLink.attr('disabled', '');
        shareSelectedLink.attr('disabled', '');
        deleteSelectedLink.attr('disabled', '');
        cloneSelectedLink.attr('disabled', '');
        enableSelectedLink.attr('disabled', '');

        executeSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');
        editSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');
        shareSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');
        deleteSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');
        cloneSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');
        enableSelectedLinkHolder.attr('original-title', notSelectedText).tooltip('enable');

      } else {
        if (selectedScheduledIssues.some(function (scheduledIssue) {
          return !scheduledIssue.validationResult.valid;
        })) {
          executeSelectedLink.attr('disabled', '');
          executeSelectedLinkHolder.attr('original-title',
            AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.invalid-selected-tooltip'))
            .tooltip('enable');
        }

          if (selectedScheduledIssues.length > 1) {
              var issueTypeId = selectedScheduledIssues[0].issueTypeId;
              var projectKey = selectedScheduledIssues[0].projectKey;
              for (var i = 1; i < selectedScheduledIssues.length; i++) {
                  if (issueTypeId != selectedScheduledIssues[i].issueTypeId) {
                      editSelectedLink.attr("disabled", "");
                      editSelectedLinkHolder.attr("original-title",
                          AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.issue-type-mismatch-tooltip")).tooltip("enable");
                  } else if (projectKey != selectedScheduledIssues[i].projectKey) {
                      editSelectedLink.attr("disabled", "");
                      editSelectedLinkHolder.attr("original-title",
                          AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.project-mismatch-tooltip")).tooltip("enable");
                  }
              }
          }

          var selectedIssuesData = {
              issueId: selectedScheduledIssues.map(function (scheduledIssue) {
                  return scheduledIssue.id;
              }),
          };

          var ajaxRequest = jQueryTS.ajax({
              "type": "GET",
              "url": AJS.contextPath() + "/rest/thescheduler/1.0/users/permissions",
              "dataType": "json",
              data: selectedIssuesData,
              "async": false,
              traditional: true,
          }).done(function (response) {
              if (!response.owner) {
                  shareSelectedLink.attr("disabled", "");
                  shareSelectedLinkHolder.attr("original-title",
                      AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.unallowed-share-tooltip")).tooltip("enable");
              }
          });
      }
    }

        jQueryTS("body").on("click", "input.select-one", selectionChanged);
        jQueryTS("body").on("click", "input.select-all", selectionChanged);

      function licenseCheckRequest() {
        return jQueryTS.ajax({
          'type': 'GET',
          'url': AJS.contextPath() + '/rest/thescheduler/1.0/validations/license',
          'async': true,
        });
      }

      function showLicenseError() {
        var ErrorDialog = TheScheduler.namespace('TheScheduler.View.ErrorDialog');
        var errorDialog = new ErrorDialog(AJS.I18n.getText("pl.com.tt.thescheduler.errors.license"), AJS.I18n.getText('pl.com.tt.thescheduler.errors.license.disabled-feature'));
        errorDialog.show();
      }

      AJS.$('#execute-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });
      AJS.$('#edit-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });
      AJS.$('#share-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });
      AJS.$('#delete-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });
      AJS.$('#clone-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });
      AJS.$('#enable-selected-button-holder').attr('title', '').tooltip({ gravity: 's', html: true });

        selectionChanged();
        /* DISABLE UNALLOWED BUTTONS ENDS */

        /* GET DATA AND DRAW TABLE */
        refreshScheduledIssues()
    }

    initScheduledIssuesTab();
});
