TheScheduler.namespace("TheScheduler.View.CloneDialog");

TheScheduler.View.CloneDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */

    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_scheduledIssue, _onClone) {

        var CloneDialog = TheScheduler.namespace("TheScheduler.View.CloneDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof CloneDialog)) {
            return new CloneDialog(_scheduledIssue, _onClone);
        }

        /* PRIVATE MEMBERS */
        var scheduledIssue = _scheduledIssue;
        var onClone = _onClone;
        var dialog = null;
        var dialogId = "#tsp-si-clone-dialog";


        /* PRIVATE METHODS */
        var show = function () {
            dialog.show();
        };

        var hide = function () {
            dialog.hide();
            AJS.dialog2(dialogId).remove();
        };

        var projectIssueField = function () {
            AJS.$.ajax(AJS.contextPath() + '/rest/thescheduler/1.0/project/jira-or-project-admin', {
                dataType: 'json',
            }).done(function (projects) {
                var projSelect = jQuery('#projectPicker');
                AJS.$.each(projects, function (idx, project) {
                    if (scheduledIssue.projectKey === project.key) {
                        projSelect.append('<option value=" ' + project.key + '" selected>' + project.name + '</option>');
                    } else {
                        projSelect.append('<option value=" ' + project.key + '">' + project.name + '</option>');
                    }
                });
//                projSelect.select2();
                projSelect.select();
            });

        }

        var initDialog = function () {
            var clonePanelContent = TheScheduler.Templates.Dialogs.clonePanel();
            AJS.$("body").append(clonePanelContent);

            var dialog = AJS.dialog2(dialogId);
            var thisDialogElement = AJS.$(dialogId);
            var cloneProgress = AJS.$("#clone-progress");
            var noNameErrorDiv = AJS.$("#no-name-error-div");
            var nameNotUniqueErrorDiv = AJS.$("#name-not-unique-error-div");
            var licenseNotValid = AJS.$("#license-is-not-valid");
            var nameOfNameField = AJS.$("input#clone-name-tf");
            var nameOfDesctiptionField = AJS.$("input#clone-description-tf");

            var requestData = { projectId: scheduledIssue.projectId };
            jQueryTS.ajax({
                type: "GET",
                url: AJS.contextPath() + "/rest/thescheduler/1.0/users/permissions",
                dataType: "json",
                async: true,
                data: requestData,
                success: function (response) {
                    if (!AJS.$("select#projectPicker").html() && (response.projectAdmin || response.admin)) {
                        thisDialogElement.find("#tsp-si-clone-form").append('<div class="field-group">' +
                            '<label>Project</label>' +
                            '<select id="projectPicker" name="projectPicker" data-container-class="project-ss" class="select project-field" autocomplete="off">' +
                            '</select>' +
                            '</div-->');
                        projectIssueField();
                    }
                },
                fail: function () {
                }
            });

            cloneProgress.hide();
            nameOfNameField.val(AJS.$('#jiraClonePrefix').val() + scheduledIssue.name);
            nameOfDesctiptionField.val(scheduledIssue.description);
            noNameErrorDiv.hide();
            nameNotUniqueErrorDiv.hide();
            licenseNotValid.hide();


            AJS.$("#tsp-si-clone-close-button").click(function (e) {
                e.preventDefault();
                hide();
            });

            AJS.$("#tsp-si-clone-button").click(function (e) {
                e.preventDefault();
                var projectPickerValue = scheduledIssue.projectKey;
                var projectPicker = AJS.$("#projectPicker option:selected");
                if (typeof projectPicker.val() != 'undefined') {
                    projectPickerValue = projectPicker.val().trim();
                }

                // show wait icon just after user clicks the button Clone
                cloneProgress.show();
                // hide previously shown error messages
                noNameErrorDiv.hide();
                nameNotUniqueErrorDiv.hide();
                licenseNotValid.hide();

                // get user input
                var cloneName = jQueryTS("#clone-name-tf", thisDialogElement);
                var cloneDescription = jQueryTS("#clone-description-tf", thisDialogElement);
                var editAfter = AJS.$("#editAfterClone").is(":checked");
                var redirectPath = AJS.contextPath() + '/secure/pl.com.tt.thescheduler.EditScheduledIssue!default.jspa';

                // validate given clone name
                if (cloneName.val().trim() === "") {
                    noNameErrorDiv.show();
                    cloneProgress.hide();
                } else {
                    var serializeObject = {
                        "scheduledIssueId": scheduledIssue.id,
                        "cloneName": cloneName.val().trim(),
                        "cloneDescription": cloneDescription.val(),
                        "cloneProject": projectPickerValue,
                    };

                    jQueryTS.ajax({
                        type: "POST",
                        url: AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/clone",
                        contentType: 'application/json',
                        dataType: 'json',
                        data: JSON.stringify(serializeObject),
                        async: true,
                        success: function (response) {
                            hide();
                            onClone(response, serializeObject);
                            if(editAfter) {
                              document.location.href = redirectPath + '?scheduledIssueId='+ response +'&editionAfterClone=true';
                            }
                        },
                        fail: function () {
                            nameNotUniqueErrorDiv.show();
                            cloneProgress.hide();
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                            if (errorThrown == "Forbidden") {
                                AJS.$("#license-is-not-valid").show();
                            } else {
                                nameNotUniqueErrorDiv.show();
                            }
                            cloneProgress.hide();
                        }
                    });
                }
            });

            dialog.show();
            return dialog;
        };

        /* INSTANCE INITIALIZATION */
        dialog = initDialog();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "show": show,
            "projectIssueField": projectIssueField,
            "hide": hide
        };

    };
})();
