TheScheduler.namespace("TheScheduler.View.DeleteDialog");

TheScheduler.View.DeleteDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */
    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_scheduledIssue, _onDelete) {

        var DeleteDialog = TheScheduler.namespace("TheScheduler.View.DeleteDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof DeleteDialog)) {
            return new DeleteDialog(_scheduledIssue, _onDelete);
        }

        /* PRIVATE MEMBERS */
        var scheduledIssue = _scheduledIssue;
        var onDelete = _onDelete;
        var dialogId = "#tsp-si-delete-dialog";
        var $dialog = null;

        /* PRIVATE METHODS */
        var getDialogId = function () {
            return dialogId;
        };

        var show = function () {
            $dialog.show();
        };

        var hide = function () {
            $dialog.hide();
            AJS.dialog2(dialogId).remove();
        };

        var initDialog = function () {
            var deletePanelContent = TheScheduler.Templates.Dialogs.deletePanel({
                "scheduledIssue": scheduledIssue
            });

            AJS.$("body").append(deletePanelContent);
            var $dialog = AJS.dialog2(dialogId);

            AJS.$("#tsp-si-delete-close-button").click(function (e) {
                e.preventDefault();
                hide();
            });

            AJS.$("#tsp-si-delete-button").click(function (e) {
                var deleteScheduledIssueProgress = jQueryTS("#delete-scheduled-issue-progress", jQueryTS(dialogId));
                deleteScheduledIssueProgress.hide();

                var ajaxRequest = jQueryTS.ajax({
                    "type": "DELETE",
                    "url": AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/" + scheduledIssue.id,
                    "dataType": "json",
                    "async": true
                });

                ajaxRequest.done(function (data, textStatus, jqXHR) {
                    if (jqXHR.status == 204) {
                        onDelete();
                    } else if (jqXHR.status == 404) {
                        onDelete();
                    }
                });

                ajaxRequest.always(function (data) {
//                    deleteScheduledIssueProgress.css("visibility", "hidden");
                    hide();
                });

            });

//            var deleteScheduledIssueProgress = jQueryTS("#delete-scheduled-issue-progress", jQueryTS("#delete-dialog-" + dialogId));
//            dialog.page[0].buttonpanel.prepend(deleteScheduledIssueProgress);
            return $dialog;
        };

        /* INSTANCE INITIALIZATION */
        $dialog = initDialog();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "getDialogId": getDialogId,
            "show": show,
            "hide": hide
        };

    };
})();
