TheScheduler.namespace("TheScheduler.View.DeleteSelectedDialog");

TheScheduler.View.DeleteSelectedDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */

    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_scheduledIssues, _onDeleteSelected) {

        var DeleteSelectedDialog = TheScheduler.namespace("TheScheduler.View.DeleteSelectedDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof DeleteSelectedDialog)) {
            return new DeleteSelectedDialog(_scheduledIssues, _onDeleteSelected);
        }

        /* PRIVATE MEMBERS */
        var scheduledIssues = _scheduledIssues;
        var onDeleteSelected = _onDeleteSelected;
        var dialogId = "#tsp-si-delete-selected-dialog";
        var dialog = null;

        /* PRIVATE METHODS */
        var getDialogId = function () {
            return dialogId;
        };

        var show = function () {
            dialog.show();
        };

        var hide = function () {
            dialog.hide();
            AJS.dialog2(dialogId).remove();
        };

        var initDialog = function () {
            var deleteSelectedPanelContent = TheScheduler.Templates.Dialogs.deleteSelectedPanel({
                "scheduledIssues": scheduledIssues
            });
            AJS.$("body").append(deleteSelectedPanelContent);
            var dialog = AJS.dialog2(dialogId);

            AJS.$("#tsp-si-delete-selected-close-button").click(function (e) {
                e.preventDefault();
                hide();
            });

            AJS.$("#tsp-si-delete-selected-button").click(function (e) {

                var deleteScheduledIssueProgress = jQueryTS("#delete-selected-progress", jQueryTS("#delete-selected-dialog-" + dialogId));
                deleteScheduledIssueProgress.show();

                var deleteResults = [];

                for (var i = 0; i < scheduledIssues.length; i++) {

                    var deleteResult = {};
                    deleteResult.scheduledIssueId = scheduledIssues[i].id;

                    var ajaxRequest = jQueryTS.ajax({
                        "type": "DELETE",
                        "url": AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/" + scheduledIssues[i].id,
                        "dataType": "json",
                        "async": false
                    });

                    ajaxRequest.done(function (data, textStatus, jqXHR) {

                        if (jqXHR.status === 204) {
                            deleteResult.status = "deleted";
                        } else if (jqXHR.status === 404) {
                            deleteResult.status = "not-found";
                        } else {
                            deleteResult.status = "error";
                        }
                    });

                    ajaxRequest.fail(function (data) {
                        deleteResult.status = "error";
                    });

                    ajaxRequest.always(function (data) {
                    });

                    deleteResults.push(deleteResult);
                }

                onDeleteSelected(deleteResults);
                deleteScheduledIssueProgress.hide();
                hide();

            });
            return dialog;
        };

        /* INSTANCE INITIALIZATION */
        dialog = initDialog();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "getDialogId": getDialogId,
            "show": show,
            "hide": hide
        };

    };
})();
