TheScheduler.namespace('TheScheduler.View.EnableDisableSelectedDialog');

TheScheduler.View.EnableDisableSelectedDialog = (function () {

  /* DECLARING DEPENDENCIES */

  /* STATIC PRIVATE MEMBERS */

  /* STATIC PRIVATE METHODS */

  /* STATIC INITIALIZATION */

  /* RETURNING AND OVERRIDING CONSTRUCTOR */
  return function (_scheduledIssues, _onEnableDisableSelected) {

    var EnableDisableSelectedDialog = TheScheduler.namespace('TheScheduler.View.EnableDisableSelectedDialog');

    /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
    if (!(this instanceof EnableDisableSelectedDialog)) {
      return new EnableDisableSelectedDialog(_scheduledIssues, _onEnableDisableSelected);
    }

    /* PRIVATE MEMBERS */
    var scheduledIssues = _scheduledIssues;
    var onEnableDisableSelected = _onEnableDisableSelected;
    var dialogId = '#tsp-si-enable-disable-selected-dialog';
    var dialog = null;
    var setDisable = null;

    /* PRIVATE METHODS */
    var getDialogId = function () {
      return dialogId;
    };

    var show = function () {
      dialog.show();
    };

    var hide = function () {
      dialog.hide();
      AJS.dialog2(dialogId)
        .remove();
    };

    var initDialog = function () {
      var enableDisableSelectedPanelContent = TheScheduler.Templates.Dialogs.enableDisableSelectedPanel({
        'scheduledIssues': scheduledIssues
      });
      AJS.$('body')
        .append(enableDisableSelectedPanelContent);
      var dialog = AJS.dialog2(dialogId);
      var generalErrorDiv = AJS.$('#general-error');

      AJS.$('#tsp-si-enable-selected-close-button')
        .click(function (e) {
          e.preventDefault();
          hide();
        });

      function showGeneralErrors(errors) {
        $.each(errors, function (key, message) {
          generalErrorDiv.append('<p>' + message + '</p>');
        });
        generalErrorDiv.show();
      };

      function sendHttpChangeStateRequest(data) {
        AJS.$.ajax({
          type: 'POST',
          url: AJS.contextPath() + '/rest/thescheduler/1.0/scheduled-issue/changeState/bulk',
          datatype: 'json',
          contentType: 'application/json',
          data: JSON.stringify(data),
          async: false,
          error: function (jqXHR) {
            showGeneralErrors(JSON.parse(jqXHR.responseText).errorMessages);
          }
        });
      }

      AJS.$('#tsp-si-enable-selected-radio')
        .click(function (e) {
          setDisable = false;
          AJS.$('#tsp-si-enable-disable-selected-confirm-button').removeAttr('disabled');
        });

      AJS.$('#tsp-si-disable-selected-radio')
        .click(function (e) {
          setDisable = true;
          AJS.$('#tsp-si-enable-disable-selected-confirm-button').removeAttr('disabled');
        });

      AJS.$('#tsp-si-enable-disable-selected-confirm-button')
        .click(function (e) {
          var enableScheduledIssueProgress = jQueryTS('#enable-disable-selected-progress', jQueryTS('#enable-disable-selected-dialog-' + dialogId));
          enableScheduledIssueProgress.show();
          var projectPickerValue = scheduledIssues[0].projectKey;
          var enableResults = [];

          var data = {
            scheduledIssuesIds: scheduledIssues.map(function (scheduledIssue) {
              return scheduledIssue.id;
            }),
            disable: setDisable,
            projectKey: projectPickerValue,
          };
          sendHttpChangeStateRequest(data);
          onEnableDisableSelected(enableResults);
          enableScheduledIssueProgress.hide();
          hide();
        });

      AJS.$('#tsp-si-enable-disable-selected-cancel-button')
        .click(function (e) {
          hide();
        });

      return dialog;
    };

    /* INSTANCE INITIALIZATION */
    dialog = initDialog();

    /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
    return {
      'getDialogId': getDialogId,
      'show': show,
      'hide': hide
    };

  };
})();
