TheScheduler.namespace("TheScheduler.View.ErrorDialog");

TheScheduler.View.ErrorDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */

    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_title, _errorMessage) {

        var ErrorDialog = TheScheduler.namespace("TheScheduler.View.ErrorDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof ErrorDialog)) {
            return new ErrorDialog(_title, _errorMessage);
        }

        /* PRIVATE MEMBERS */
        var title = _title;
        var errorMessage = _errorMessage;
        var dialogId = "#tsp-si-error-dialog";
        var dialog = null;

        /* PRIVATE METHODS */
        var getDialogId = function () {
            return dialogId;
        };

        var show = function () {
            dialog.show();
        };

        var hide = function () {
            dialog.hide();
            AJS.dialog2(dialogId).remove();
        };

        var initDialog = function () {
            var errorPanelContent = TheScheduler.Templates.Dialogs.errorPanel({
                "errorTitle": title,
                "errorMessage": errorMessage
            });
            AJS.$("body").append(errorPanelContent);

            var dialog = AJS.dialog2(dialogId);
            ;

            AJS.$("#tsp-si-delete-close-button").click(function (e) {
                e.preventDefault();
                hide();
            });

            return dialog;
        };

        /* INSTANCE INITIALIZATION */
        dialog = initDialog();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "getDialogId": getDialogId,
            "show": show,
            "hide": hide
        };

    };
})();
