TheScheduler.namespace("TheScheduler.View.FireConfirmationDialog");

TheScheduler.View.FireConfirmationDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */
    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_scheduledIssueId, _scheduledIssueName, _isAnySkipping, _isAnyFieldSwapping, _confirmationCallback) {

        var FireConfirmationDialog = TheScheduler.namespace("TheScheduler.View.FireConfirmationDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof FireConfirmationDialog)) {
            return new FireConfirmationDialog(_scheduledIssueId, _scheduledIssueName, _isAnySkipping, _isAnyFieldSwapping, _confirmationCallback);
        }

        /* PRIVATE MEMBERS */
        var scheduledIssueId = _scheduledIssueId;
        var scheduledIssueName = _scheduledIssueName;
        var isAnySkipping = _isAnySkipping;
        var isAnyFieldSwapping = _isAnyFieldSwapping;
        var confirmationCallback = _confirmationCallback;
        var dialogId = "#scheduler-fire-confirmation-dialog";
        var cookieSettingId = "scheduler-fire-confirmation-checkbox-dont-show";
        var $dialog = null;
        var rest = null;


        var canShow = function () {
            return jQueryTS.cookie(cookieSettingId) == "true";
        }

        var show = function () {

            if (canShow() === true && (!isAnySkipping || !isAnyFieldSwapping)) {
                confirmationCallback();
                return;
            }

            var ShowCreatedIssuesPanelContent = TheScheduler.Templates.Dialogs.fireConfirmationDialog({
                "scheduledIssueId": scheduledIssueId,
                "scheduledIssueName": scheduledIssueName,
                "isAnyTriggerSkipping": isAnySkipping,
                "isAnyFieldSwapping": isAnyFieldSwapping,
            });

            AJS.$("body").append(ShowCreatedIssuesPanelContent);
            $dialog = AJS.dialog2(dialogId);

            AJS.$("#scheduler-fire-confirmation-dialog-submit-button").click(function (e) {
                if (AJS.$("#scheduler-fire-confirmation-dialog-checkbox").prop('checked') == true) {
                    jQueryTS.cookie(cookieSettingId, "true");
                }
                confirmationCallback();
                $dialog.hide();
            });

            AJS.$("#scheduler-fire-confirmation-dialog-close-button").click(function (e) {
                $dialog.hide();
            });

            $dialog.show();
        };

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "show": show,
            "canShow": canShow
        };

    };
})();
