TheScheduler.namespace("TheScheduler.View.FireSelectedConfirmationDialog");

TheScheduler.View.FireSelectedConfirmationDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */
    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_selectedSICount, _isAnyTriggerSkipping, _isAnyFieldSwapping, _confirmationCallback) {

        var FireSelectedConfirmationDialog = TheScheduler.namespace("TheScheduler.View.FireSelectedConfirmationDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof FireSelectedConfirmationDialog)) {
            return new FireSelectedConfirmationDialog(_selectedSICount, _isAnyTriggerSkipping, _isAnyFieldSwapping, _confirmationCallback);
        }

        /* PRIVATE MEMBERS */
        var selectedSICount = _selectedSICount;
        var isAnyTriggerSkipping = _isAnyTriggerSkipping;
        var isAnyFieldSwapping = _isAnyFieldSwapping;
        var confirmationCallback = _confirmationCallback;
        var dialogId = "#scheduler-fire-selected-confirmation-dialog";
        var cookieSettingId = "scheduler-fire-confirmation-checkbox-dont-show";
        var $dialog = null;
        var rest = null;

        var canShow = function () {
            return jQueryTS.cookie(cookieSettingId) == "true";
        }

        var show = function () {

            if (canShow() == true && (!isAnyFieldSwapping || !isAnyTriggerSkipping)) {
                confirmationCallback();
                return;
            }

            var FireSelectedConfirmationPanelContent = TheScheduler.Templates.Dialogs.fireSelectedConfirmationDialog({
                "selectedSICount": selectedSICount,
                "isAnyTriggerSkipping": isAnyTriggerSkipping,
                "isAnyFieldSwapping": isAnyFieldSwapping
            });

            AJS.$("body").append(FireSelectedConfirmationPanelContent);
            $dialog = AJS.dialog2(dialogId);

            AJS.$("#scheduler-fire-selected-confirmation-dialog-submit-button").click(function (e) {
                if (AJS.$("#scheduler-fire-selected-confirmation-dialog-checkbox").prop('checked') == true) {
                    jQueryTS.cookie(cookieSettingId, "true");
                }
                confirmationCallback();
                $dialog.hide();
            });

            AJS.$("#scheduler-fire-selected-confirmation-dialog-close-button").click(function (e) {
                $dialog.hide();
            });

            $dialog.show();
        };

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "show": show,
            "canShow": canShow
        };

    };
})();
