TheScheduler.namespace("TheScheduler.Model.ScheduledIssue");

TheScheduler.Model.ScheduledIssue = (function () {

    /* STATIC PRIVATE MEMBERS */

    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_scheduledIssueJson) {

        var ScheduledIssue = TheScheduler.namespace("TheScheduler.Model.ScheduledIssue");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof ScheduledIssue)) {
            return new ScheduledIssue();
        }

        /* PRIVATE MEMBERS */
        var scheduledIssueJson = _scheduledIssueJson;

        /* PRIVATE METHODS */
        var getId = function () {
            return scheduledIssueJson.id;
        };

        var getScheduledIssueJSON = function () {
            return scheduledIssueJson;
        };

        var getName = function () {
            return scheduledIssueJson.name;
        };

        var getDescription = function () {
            return scheduledIssueJson.description;
        };

        var getSummary = function () {
            return scheduledIssueJson.summary;
        };

        var isDisabled = function () {
            return scheduledIssueJson.disabled;
        };

        var getPriority = function () {
            return scheduledIssueJson.priorityName;
        };

        var getReporter = function () {
            return scheduledIssueJson.reporter;
        };

        var getReporterFullName = function () {
            return scheduledIssueJson.reporterFullName;
        };

        var getAssignee = function () {
            return scheduledIssueJson.assignee;
        };

        var getAssigneeFullName = function () {
            return scheduledIssueJson.assigneeFullName;
        };

        var getCreatedBy = function () {
            return scheduledIssueJson.createdBy;
        };

        var getCreatedByFullName = function () {
            return scheduledIssueJson.createdByFullName;
        };

        var getCreatedAt = function () {
            return scheduledIssueJson.createdAt;
        };

        var getCreatedAtFormatted = function () {
            return scheduledIssueJson.createdAtFormatted;
        };

        var getModifiedBy = function () {
            return scheduledIssueJson.modifiedBy;
        };

        var getModifiedByFullName = function () {
            return scheduledIssueJson.modifiedByFullName;
        };

        var getModifiedAt = function () {
            return scheduledIssueJson.modifiedAt;
        };

        var getModifiedAtFormatted = function () {
            return scheduledIssueJson.modifiedAtFormatted;
        };

        var getPrevFireTime = function () {
            return scheduledIssueJson.prevFireTime;
        };

        var getPrevFireTimeFormatted = function () {
            return scheduledIssueJson.prevFireTimeFormatted;
        };

        var getNextFireTime = function () {
            return scheduledIssueJson.nextFireTime;
        };

        var getNextFireTimeFormatted = function () {
            return scheduledIssueJson.nextFireTimeFormatted;
        };

        var getFireCount = function () {
            return scheduledIssueJson.fireCount;
        };

        var getTriggers = function () {
            var triggers = [];

            var ajaxRequest = jQueryTS.ajax({
                "type": "GET",
                "url": AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/" + getId() + "/trigger",
                "dataType": "json",
                "async": false
            });

            ajaxRequest.done(function (data) {
                if (data instanceof Array) {
                    for (var i = 0; i < data.length; i++) {
                        var triggerJson = data[i];
                        var trigger = new Trigger(triggerJson);
                        triggers.push(trigger);
                    }
                }
            });

            return triggers;
        };

        var isAnyTriggerSkipping = function() {
            return scheduledIssueJson.anyTriggerSkipping;
        }

        var isSwappingAssigneeField = function() {
            return scheduledIssueJson.swappingAssigneeField;
        };

        var isSwappingReporterField = function() {
            return scheduledIssueJson.swappingReporterField;
        };

        var isSwappingAnyUserField = function() {
            return scheduledIssueJson.swappingAnyUserField;
        };


        /* INSTANCE INITIALIZATION */

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        this.getId = getId;
        this.getScheduledIssueJSON = getScheduledIssueJSON;
        this.getName = getName;
        this.getDescription = getDescription;
        this.getSummary = getSummary;
        this.isDisabled = isDisabled;
        this.getPriority = getPriority;
        this.getReporter = getReporter;
        this.getReporterFullName = getReporterFullName;
        this.getAssignee = getAssignee;
        this.getAssigneeFullName = getAssigneeFullName;
        this.getCreatedBy = getCreatedBy;
        this.getCreatedByFullName = getCreatedByFullName;
        this.getCreatedAt = getCreatedAt;
        this.getCreatedAtFormatted = getCreatedAtFormatted;
        this.getModifiedBy = getModifiedBy;
        this.getModifiedByFullName = getModifiedByFullName;
        this.getModifiedAt = getModifiedAt;
        this.getModifiedAtFormatted = getModifiedAtFormatted;
        this.getPrevFireTime = getPrevFireTime;
        this.getPrevFireTimeFormatted = getPrevFireTimeFormatted;
        this.getNextFireTime = getNextFireTime;
        this.getNextFireTimeFormatted = getNextFireTimeFormatted;
        this.getFireCount = getFireCount;
        this.getTriggers = getTriggers;
        this.isAnyTriggerSkipping = isAnyTriggerSkipping;
        this.isSwappingAssigneeField = isSwappingAssigneeField;
        this.isSwappingReporterField = isSwappingReporterField;
        this.isSwappingAnyUserField = isSwappingAnyUserField;

    };

})();
