TheScheduler.namespace("TheScheduler.View.ShowCalendarDatesDialog");

TheScheduler.View.ShowCalendarDatesDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */
    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_calendarName, _calendarDates, _calendarType) {

        var ShowCalendarDatesDialog = TheScheduler.namespace("TheScheduler.View.ShowCalendarDatesDialog");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof ShowCalendarDatesDialog)) {
            return new ShowCalendarDatesDialog(_calendarName, _calendarDates, _calendarType);
        }

        /* PRIVATE MEMBERS */
        var calendarName = _calendarName;
        var calendarDates = _calendarDates;
        var calendarType = _calendarType;
        var dialogId = "#tsp-show-calendar-dates-dialog";
        var tableId = "#tsp-show-calendar-dates-dialog-table";
        var paginateId = "#tsp-show-calendar-dates-dialog-table_paginate";
        var $dialog = null;
        var table = null;

        /* PRIVATE METHODS */
        var getDialogId = function () {
            return dialogId;
        };

        var show = function () {
            $dialog.show();
        };

        var initDialog = function () {
            var ShowCalendarDatesDialogContent = TheScheduler.Templates.Dialogs.showCalendarDatesDialog({
                "calendarName": calendarName,
                "calendarType": calendarType
            });

            AJS.$("body").append(ShowCalendarDatesDialogContent);
            var $dialog = AJS.dialog2(dialogId);

            AJS.$("#tsp-show-calendar-dates-dialog-close-button").click(function (e) {
                $dialog.hide();
            });

            return $dialog;
        };

        function drawCallback(oSettings) {
            if (oSettings.fnRecordsDisplay() == 0) {
                AJS.$(paginateId).hide();
            } else {
                AJS.$(paginateId).show();
            }
        }

        var initDataTable = function () {
            return jQueryTS(tableId).dataTable({
                bSort: true,
                bFilter: false,
                bInfo: false,
                bLengthChange: false,
                bPaginate: true,
                sPaginationType: "full_numbers",
                bAutoWidth: true,
                sDom: "lrtip",
                bDestroy: true,
                fnDrawCallback: drawCallback,
                aoColumnDefs: [
                    {
                        sType: "string",
                        sClass: "date-description-column",
                        mData: "description",
                        bSortable: true,
                        aTargets: [0]
                    },
                    {
                        sType: "data",
                        sClass: "date-date-column",
                        mData: "date",
                        bSortable: true,
                        aTargets: [1]
                    }

                ],
                aaData: calendarDates,
                oLanguage: {
                    sEmptyTable: AJS.I18n.getText("pl.com.tt.thescheduler.dialogs.no-calendar-dates"),
                    oPaginate: {
                        sFirst: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.first"),
                        sLast: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.last"),
                        sNext: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.next"),
                        sPrevious: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.previous")
                    }
                },
            });
        }

        /* INSTANCE INITIALIZATION */
        $dialog = initDialog();
        table = initDataTable();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "getDialogId": getDialogId,
            "show": show
        };

    };
})();
