TheScheduler.namespace("TheScheduler.View.ShowFutureFiresDialog");

TheScheduler.View.ShowFutureFiresDialog = (function () {

    /* DECLARING DEPENDENCIES */

    /* STATIC PRIVATE MEMBERS */
    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_selectedScheduledIssuesIdsArray, _selectedScheduledIssuesNamesArray, _projectId, _projectName) {

        var ShowFutureFiresDialog = TheScheduler.namespace("TheScheduler.View.ShowFutureFiresDialog");
        var CurrentIsoDate = TheScheduler.namespace("TheScheduler.Utils.DateUtils");
        var Common = TheScheduler.namespace("TheScheduler.Utils.Common")

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof ShowFutureFiresDialog)) {
            return new ShowFutureFiresDialog(_selectedScheduledIssuesIdsArray, _selectedScheduledIssuesNamesArray, _projectId, _projectName);
        }

        /* PRIVATE MEMBERS */
        var projectId = _projectId;
        var projectName = _projectName;
        var selectedScheduledIssuesIdsArray = _selectedScheduledIssuesIdsArray;
        var selectedScheduledIssuesNamesArray = _selectedScheduledIssuesNamesArray;
        var dialogId = "#tsp-si-show-future-fires-dialog";
        var triggerTableId = "#future-fires-table";
        var upcomingExecutionsLimitAmountId = "#upcoming-executions-limit-amount";
        var $dialog = null;
        var table = null;

        /* PRIVATE METHODS */
        var getDialogId = function () {
            return dialogId;
        };

        var show = function () {
            $dialog.show();
        };

        var hide = function () {
            table.fnDestroy();
            setTimeout(function() {
                AJS.$(".scheduler-tooltip-enabled").tooltip("hide");//Fix for non-hiding tooltips on dialog triggering button
            }, 1000);
        };

      var initDialog = function () {
        var selectedScheduledIssuesJoinedArray = '';
        var selectedScheduledIssuesArrayLength = 0;
        if (selectedScheduledIssuesNamesArray) {
          selectedScheduledIssuesJoinedArray = selectedScheduledIssuesNamesArray.join(', ');
          selectedScheduledIssuesArrayLength = selectedScheduledIssuesNamesArray.length;
        }

          var showFutureFiresPanelContent = TheScheduler.Templates.Dialogs.showFutureFiresPanel({
                "scheduledIssueName": selectedScheduledIssuesJoinedArray,
                "selectedSILength": selectedScheduledIssuesArrayLength,
                "projectName": projectName,
                "minDate": CurrentIsoDate.getCurrentIsoDate
            });

            AJS.$("body").append(showFutureFiresPanelContent);
            var $dialog = AJS.dialog2(dialogId);

            AJS.$("#tsp-si-show-future-fires-close-button").click(function (e) {
                $dialog.hide();
            });

            AJS.$('#upcoming-issues-table-blanket').show();

            AJS.dialog2("#tsp-si-show-future-fires-dialog").on("hide", function (e) {
                hide();
            });

            AJS.$("#future-fires-filter-input").bind("input", AJS.$.debounce(250, function () {
                filter(AJS.$(this).val());
            }));

            getOptionsForSelect();

            AJS.$(upcomingExecutionsLimitAmountId).change(refresh);

            AJS.$("#upcoming-executions-limit-by-amount").click(function () {
                AJS.$('#upcoming-executions-limit-date-picker').hide();
                AJS.$('#total-amount-upcoming-executions').hide();
                AJS.$("#upcoming-executions-limit-amount-picker").show();
                refresh();
            });

        AJS.$('#upcoming-executions-limit-date-picker').hide();

        AJS.$('#upcoming-executions-limit-by-date')
            .click(function () {
              AJS.$('#upcoming-executions-limit-amount-picker')
                .hide();
              AJS.$('#total-amount-upcoming-executions')
                .show();
              AJS.$('#upcoming-executions-limit-date-picker')
                .show();

              const tableData = table.api().data();
              const entriesLength = tableData.length;

              var dateValue = new Date();
              if (entriesLength) {
                const lastEntryTimestamp = tableData.toArray()
                  .reverse()
                  .map(function (entry) {
                    return entry.executionTimestamp;
                  })
                  .find(function (executionTimestamp) {
                      if (executionTimestamp) {
                        return true;
                      }
                      return false;
                    }
                  );
                if (lastEntryTimestamp) {
                  dateValue = new Date(lastEntryTimestamp);
                }
              }

              AJS.$('#upcoming-executions-limit-date')
                .val(dateValue.toISOString()
                  .slice(0, 10));
              refreshByDate();
            });

            AJS.$("#upcoming-executions-limit-date").datePicker({
                overrideBrowserDefault: true,
                firstDay: -1
            });

            AJS.$("#upcoming-executions-limit-date").change(refreshByDate);

            AJS.$(".scheduler-tooltip-enabled").tooltip();

            return $dialog;
        };

        var filter = function (text) {
            table.fnFilter(text);
        };

        var getOptionsForSelect = function(appendCompletedCallback) {
            var url = AJS.contextPath() + "/rest/thescheduler/1.0/global/properties";
            var defaultValues = [10, 20, 50, 100, 200, 500];

            var ajaxRequest = jQueryTS.ajax({
                "type": "GET",
                "url": url,
                "dataType": "json",
                "async": true
            });

            ajaxRequest.done(function (data) {
                for(i=0; i<=defaultValues.length-1; i++){
                    if(defaultValues[i] <= data.maxAmountFutureFireTimes){
                        if(i === 0){
                            AJS.$(upcomingExecutionsLimitAmountId).append('<option value=\"' + defaultValues[i] + '\" selected=\"selected\">' + defaultValues[i] + '</option>');
                            continue
                        }
                        if(defaultValues[i] === data.maxAmountFutureFireTimes){
                            AJS.$(upcomingExecutionsLimitAmountId).append('<option value=\"' + defaultValues[i] + '\">' + defaultValues[i] + '</option>');
                            break;
                        }
                        AJS.$(upcomingExecutionsLimitAmountId).append('<option value=\"' + defaultValues[i] + '\">' + defaultValues[i] + '</option>');
                    }

                    if(i === defaultValues.length-1 && defaultValues[i] < data.maxAmountFutureFireTimes){
                        AJS.$(upcomingExecutionsLimitAmountId).append('<option value=\"' +  data.maxAmountFutureFireTimes + '\">' +  data.maxAmountFutureFireTimes + '</option>');
                        break;
                    }

                    if(i > 0 && i < defaultValues.length-1 && defaultValues[i+1] > data.maxAmountFutureFireTimes){
                        AJS.$(upcomingExecutionsLimitAmountId).append('<option value=\"' +  data.maxAmountFutureFireTimes + '\">' +  data.maxAmountFutureFireTimes + '</option>');
                        break;
                    }
                }
                refresh();
            });
        };

        var refreshByDate = function (refreshCompletedCallback) {
            AJS.$("#future-fires-loading").show();
            AJS.$("#upcoming-executions-limit-date").attr("disabled", "");
            var dateLimit = AJS.$("#upcoming-executions-limit-date").val();

            var url = null;

            if(selectedScheduledIssuesIdsArray) {
                var queryParams = "?scheduledIssueId=" + selectedScheduledIssuesIdsArray.join("&scheduledIssueId=");
                url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times-selected/limit"
                        + queryParams + "&date=" + dateLimit;
            }
            else {
                if(projectId === null){
                    url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times/limit?date=" + dateLimit;
                } else {
                    url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times/limit?date=" + dateLimit + "&projectId=" + projectId;
                }
            }

            var ajaxRequest = jQueryTS.ajax({
                "type": "GET",
                "url": url,
                "dataType": "json",
                "async": true
            });

            ajaxRequest.done(function (data) {
                var allFiresLength = 0;
                table.fnClearTable(true);
                if (AJS.$.isArray(data.entries) && data.entries.length > 0) {
                    allFiresLength = data.entries.length;
                    table.fnAddData(data.entries, true);
                }
                setExportButtonStatusAndClick(allFiresLength);
                if (data.limitReached) {
                    const messages = [AJS.I18n.getText("pl.com.tt.thescheduler.errors.issues.limit", data.entries.length),
                        AJS.I18n.getText('pl.com.tt.thescheduler.errors.issues.over-limit')];
                    Common.showLimitReachedFlag(messages);
                }
                AJS.$("#total-amount-upcoming-executions").text(AJS.I18n.getText('pl.com.tt.thescheduler.dialogs.upcoming-executions.total') + ": " + (allFiresLength));
            });

            ajaxRequest.always(function () {
                if (typeof refreshCompletedCallback === "function") {
                    refreshCompletedCallback();
                }
                AJS.$("#future-fires-loading").hide();
                AJS.$("#upcoming-executions-limit-date").removeAttr("disabled");
            });
        };

        var exportCsvFile = function (event) {
            event.preventDefault();
            event.stopPropagation();

            var filterText = encodeURIComponent(AJS.$("#future-fires-filter-input").val());
            var limit = AJS.$(upcomingExecutionsLimitAmountId).val();
            var dateLimit = AJS.$("#upcoming-executions-limit-date").val();

            var limitByDate = AJS.$("#upcoming-executions-limit-by-date").prop("checked");
            var urlParams = {
                filterText: filterText,
                date: limitByDate ? dateLimit : undefined,
                limit: limitByDate ? undefined : limit,
                projectId: projectId !== null ? projectId : undefined
            }

            var queryParams = null;
            if(selectedScheduledIssuesIdsArray) {
                queryParams = "&scheduledIssueId=" + selectedScheduledIssuesIdsArray.join("&scheduledIssueId=");
            }
            window.location.href = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times"
                + (selectedScheduledIssuesIdsArray !== null ? "-selected/csv" : "/csv")
                + (limitByDate ? "/limit?" : "?") + AJS.$.map(AJS.$.extend({}, urlParams), function (value, key) {
                    return key + "=" + value;
                }).join('&') + (selectedScheduledIssuesIdsArray !== null ? queryParams : "");
        }

        var refresh = function (refreshCompletedCallback) {

            AJS.$("#future-fires-loading").show();
            AJS.$(upcomingExecutionsLimitAmountId).attr("disabled", "");
            var limit = AJS.$(upcomingExecutionsLimitAmountId).val();

            if(limit == null) {
                return;
            }

            var url = null;
            if (selectedScheduledIssuesIdsArray) {
                var queryParams = "?scheduledIssueId=" + selectedScheduledIssuesIdsArray.join("&scheduledIssueId=");
                url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times-selected"
                    + queryParams + "&limit=" + limit;
            }
            else {
                if (projectId === null) {
                    url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times?limit=" + limit;
                } else {
                    url = AJS.contextPath() + "/rest/thescheduler/1.0/scheduled-issue/fire-times?projectId=" + projectId + "&limit=" + limit;
                }
            }

            var ajaxRequest = jQueryTS.ajax({
                "type": "GET",
                "url": url,
                "dataType": "json",
                "async": true
            });

            ajaxRequest.done(function (response) {
                var data = response.entries;
                setExportButtonStatusAndClick(data.length);
                table.fnClearTable(true);
                if (AJS.$.isArray(data) && data.length > 0) {
                    table.fnAddData(data, true);
                }
                AJS.$("#total-amount-upcoming-executions").text(AJS.I18n.getText('pl.com.tt.thescheduler.dialogs.upcoming-executions.total')+ ": " + (data.length));
            });

            ajaxRequest.always(function () {
                if (typeof refreshCompletedCallback === "function") {
                    refreshCompletedCallback();
                }
                AJS.$("#future-fires-loading").hide();
                AJS.$('#upcoming-issues-table-blanket').hide();
                AJS.$(upcomingExecutionsLimitAmountId).removeAttr("disabled");
            });
        };

        var setExportButtonStatusAndClick = function(count) {
            if(count >= 1) {
                AJS.$("#tsp-export-upcoming-executions-button").removeAttr("aria-disabled");
                AJS.$("#tsp-export-upcoming-executions-button").removeAttr("title");
                AJS.$("#tsp-export-upcoming-executions-button").removeAttr("original-title");
                AJS.$("#tsp-export-upcoming-executions-button").click(exportCsvFile);
            }
            else {
                AJS.$("#tsp-export-upcoming-executions-button").attr("aria-disabled", "true");
                AJS.$("#tsp-export-upcoming-executions-button").attr("title", AJS.I18n.getText('pl.com.tt.thescheduler.tabpanel.nothing-to-export'));
                AJS.$("#tsp-export-upcoming-executions-button").off('click');
            }
        }

        function renderExecutionResultColumn(data, type, row) {
            return TheScheduler.Templates.Dialogs.executionResultColumn({
                "createdIssue": row,
                dialogType: 'UPCOMING',
            });
        }

        function renderScheduledIssueNameColumn(data, type, row) {
            return TheScheduler.Templates.Dialogs.renderScheduledIssueNameColumn({
                "createdIssue": row,
                "contextPath": AJS.contextPath()
            });
        }

        function renderScheduledIssueProjectColumn(data, type, row) {
            return TheScheduler.Templates.Dialogs.projectColumn({
                createdIssue: row,
                contextPath: AJS.contextPath()
            });
        }

        function drawCallback(oSettings) {
            if (oSettings.fnRecordsDisplay() == 0) {
                AJS.$("#future-fires-table_paginate").hide();
            } else {
                AJS.$("#future-fires-table_paginate").show();
            }
        }

        var initDataTable = function () {
            return jQueryTS(triggerTableId).dataTable({
                bSort: false,
                bFilter: true,
                bInfo: false,
                bLengthChange: false,
                bPaginate: true,
                sPaginationType: "full_numbers",
                bAutoWidth: true,
                sDom: "lrtip",
                bDeferRender: true,
                bDestroy: true,
                fnDrawCallback: drawCallback,
                aoColumnDefs: [
                    {
                        sType: "string",
                        sClass: "execution-time-column",
                        mData: "executionTimeString",
                        bSortable: false,
                        aTargets: [0]
                    },
                    {
                        sType: "string",
                        sClass: "scheduled-issue-name-column",
                        mRender: renderScheduledIssueNameColumn,
                        bSortable: false,
                        aTargets: [1]
                    },
                    {
                        sType: "string",
                        sClass: "scheduled-issue-project-column",
                        mRender: renderScheduledIssueProjectColumn,
                        bSortable: false,
                        aTargets: [2],
                        visible: !projectId
                    },
                    {
                        sType: "string",
                        sClass: "action-column",
                        mRender: renderExecutionResultColumn,
                        bSortable: false,
                        aTargets: [3]
                    },

                ],
                aaData: [],
                oLanguage: {
                    sEmptyTable: AJS.I18n.getText("pl.com.tt.thescheduler.dialogs.no-upcoming-executions"),
                    sZeroRecords: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.empty-filter"),
                    oPaginate: {
                        sFirst: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.first"),
                        sLast: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.last"),
                        sNext: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.next"),
                        sPrevious: AJS.I18n.getText("pl.com.tt.thescheduler.tabpanel.pagination.previous")
                    }
                },
            });
        }

        /* INSTANCE INITIALIZATION */
        $dialog = initDialog();
        table = initDataTable();
        refresh();

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        return {
            "getDialogId": getDialogId,
            "show": show,
            "hide": hide
        };

    };
})();
