TheScheduler.namespace("TheScheduler.Model.Trigger");

TheScheduler.Model.Trigger = (function () {

    /* STATIC PRIVATE MEMBERS */

    /* STATIC PRIVATE METHODS */

    /* STATIC INITIALIZATION */

    /* RETURNING AND OVERRIDING CONSTRUCTOR */
    return function (_triggerJson) {

        var Trigger = TheScheduler.namespace("TheScheduler.Model.Trigger");

        /* IN CASE SOMEONE FORGOT USING *NEW* KEYWORD */
        if (!(this instanceof Trigger)) {
            return new Trigger(_triggerJson);
        }

        /* PRIVATE MEMBERS */
        var triggerJson = null;

        /* PRIVATE METHODS */
        var getId = function () {
            return triggerJson.id;
        };

        var getTriggerJSON = function () {
            return triggerJson;
        };

        var getTriggerType = function () {
            return triggerJson.triggerType;
        };

        var getTriggerExpression = function () {
            return triggerJson.triggerExpression;
        };

        var getTriggerExpressionSummary = function () {
            return triggerJson.triggerExpressionSummary;
        };

        var getCronExpression = function () {
            return triggerJson.cronExpression;
        };

        var getTimeZone = function () {
            return triggerJson.timeZone;
        }

        var getTimeZoneFormatted = function () {
            return triggerJson.timeZoneFormatted;
        }

        var getIntervalType = function () {
            return triggerJson.intervalType;
        }

        var getIntervalDivider = function () {
            return triggerJson.intervalDivider;
        }

        var getExecutionDate = function () {
            return triggerJson.executionDate;
        }

        var getStartDate = function () {
            return triggerJson.startDate;
        };

        var getEndDate = function () {
            return triggerJson.endDate;
        };

        var getStartDateFormatted = function () {
            return triggerJson.startDateFormatted;
        };

        var getEndDateFormatted = function () {
            return triggerJson.endDateFormatted;
        };

        var getExecutionDateFormatted = function () {
            return triggerJson.executionDateFormatted;
        };

        var getWorkflowTriggerIssueTypeId = function () {
            return triggerJson.workflowTriggerIssueTypeId;
        }

        var getExecuteOnAllSourceStatuses = function () {
            return triggerJson.executeOnAllSourceStatuses;
        }

        var getSourceStatusId = function () {
            return triggerJson.sourceStatusId;
        }

        var getExecuteOnAllTargetStatuses = function () {
            return triggerJson.executeOnAllTargetStatuses;
        }

        var getTargetStatusId = function () {
            return triggerJson.targetStatusId;
        }

        var getSkipScheduledExecutionAfterManual = function () {
            return triggerJson.skipScheduledExecutionAfterManual;
        }

        var getRecentManualExecutionSj = function () {
            return triggerJson.recentManualExecutionSj;
        }

        /* INSTANCE INITIALIZATION */
        if (_triggerJson) {
            triggerJson = {
                "id": _triggerJson.id || null,
                "triggerType": _triggerJson.triggerType || null,
                "triggerExpression": _triggerJson.triggerExpression || null,
                "triggerExpressionSummary": _triggerJson.triggerExpressionSummary || null,
                "cronExpression": _triggerJson.cronExpression || null,
                "timeZone": _triggerJson.timeZone || null,
                "timeZoneFormatted": _triggerJson.timeZoneFormatted || null,
                "intervalType": _triggerJson.intervalType || null,
                "intervalDivider": _triggerJson.intervalDivider || null,
                "executionDate": _triggerJson.executionDate || null,
                "executionDateFormatted": _triggerJson.executionDateFormatted || null,
                "startDate": _triggerJson.startDate || null,
                "startDateFormatted": _triggerJson.startDateFormatted || null,
                "endDate": _triggerJson.endDate || null,
                "endDateFormatted": _triggerJson.endDateFormatted || null,
                "workflowTriggerIssueTypeId": _triggerJson.workflowTriggerIssueTypeId || null,
                "executeOnAllSourceStatuses": _triggerJson.executeOnAllSourceStatuses || false,
                "sourceStatusId": _triggerJson.sourceStatusId || null,
                "executeOnAllTargetStatuses": _triggerJson.executeOnAllTargetStatuses || false,
                "targetStatusId": _triggerJson.targetStatusId || null,
                "skipScheduledExecutionAfterManual": _triggerJson.skipScheduledExecutionAfterManual || false,
                "recentManualExecutionSj": _triggerJson.recentManualExecutionSj || false
            };
        }

        /* RETURNING ONLY DESIRABLE MEMBERS AND METHODS */
        this.getId = getId;
        this.getTriggerJSON = getTriggerJSON;
        this.getTriggerType = getTriggerType;
        this.getTriggerExpression = getTriggerExpression;
        this.getTriggerExpressionSummary = getTriggerExpressionSummary;
        this.getCronExpression = getCronExpression;
        this.getTimeZone = getTimeZone;
        this.getTimeZoneFormatted = getTimeZoneFormatted;
        this.getIntervalType = getIntervalType;
        this.getIntervalDivider = getIntervalDivider;
        this.getExecutionDate = getExecutionDate;
        this.getStartDate = getStartDate;
        this.getEndDate = getEndDate;
        this.getExecutionDateFormatted = getExecutionDateFormatted;
        this.getStartDateFormatted = getStartDateFormatted;
        this.getEndDateFormatted = getEndDateFormatted;
        this.getWorkflowTriggerIssueTypeId = getWorkflowTriggerIssueTypeId;
        this.getExecuteOnAllSourceStatuses = getExecuteOnAllSourceStatuses;
        this.getSourceStatusId = getSourceStatusId;
        this.getExecuteOnAllTargetStatuses = getExecuteOnAllTargetStatuses;
        this.getTargetStatusId = getTargetStatusId;
        this.getSkipScheduledExecutionAfterManual = getSkipScheduledExecutionAfterManual;
        this.getRecentManualExecutionSj = getRecentManualExecutionSj;
    };
})();
